      .386                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive
  
;     include files
;     ~~~~~~~~~~~~~
      include \masm32\include\windows.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc

;     libraries
;     ~~~~~~~~~
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib

.data
     b2hlut  db "000102030405060708090A0B0C0D0E0F"
             db "101112131415161718191A1B1C1D1E1F"
             db "202122232425262728292A2B2C2D2E2F"
             db "303132333435363738393A3B3C3D3E3F"
             db "404142434445464748494A4B4C4D4E4F"
             db "505152535455565758595A5B5C5D5E5F"
             db "606162636465666768696A6B6C6D6E6F"
             db "707172737475767778797A7B7C7D7E7F"
             db "808182838485868788898A8B8C8D8E8F"
             db "909192939495969798999A9B9C9D9E9F"
             db "A0A1A2A3A4A5A6A7A8A9AAABACADAEAF"
             db "B0B1B2B3B4B5B6B7B8B9BABBBCBDBEBF"
             db "C0C1C2C3C4C5C6C7C8C9CACBCCCDCECF"
             db "D0D1D2D3D4D5D6D7D8D9DADBDCDDDEDF"
             db "E0E1E2E3E4E5E6E7E8E9EAEBECEDEEEF"
             db "F0F1F2F3F4F5F6F7F8F9FAFBFCFDFEFF"
     testdd  dd 12345678h
     szbuff  db "Dword is "
     hexstr  dw 0,0,0,0,104,0        ; 104 word == "h",0 bytes
     szTitle db "Display hex dword by fast lookup",0

.code
start:
        lea   esi, testdd
        lea   edi, hexstr

        add   esi, 4
        sub   edi, 2

      REPEAT 4
        dec   esi
        inc   edi
        inc   edi
        movzx ecx, byte ptr [esi]
        mov   ax, word ptr [b2hlut+ecx*2]
        mov   [edi], ax
      ENDM

        invoke MessageBox, NULL,addr szbuff, addr szTitle, MB_OK
        invoke ExitProcess, 0
end start        